<?php
	require_once('config.php');
	error_reporting(E_CONFIG);
	
	abstract class cRecord{
		protected $record;
		protected $db;
		protected $cache;
		
		public function __construct(&$_db, &$_record = null){
			$this->db =& $_db; if($_record != null) $this->record = $_record;
		}

		abstract public function openRecID($_recid);
		public function openRecord(&$_record){ $this->record = $_record; }
		
		public function guid(){ return $this->fieldRO('f1_GUID'); }
		public function RecID(){ return $this->fieldRO('s_RecID'); }
		
		public function getCache(){
			if(!isset($this->cache['s_RecID'])){
				$this->RecID(); }
			return $this->cache;
			}
		public function setCache($_cache){ $this->cache = $_cache; }

		protected function fieldRO($_port){ return $this->field($_port); }
		
		public function duplicate(){ return new cHour($this->db, $this->record->duplicate()); }
	}
	
	abstract class cRecordRW extends cRecord{
		protected function field($_port, $_str = null){
			if($_str !== null){
				$this->record->setField($_port, $_str);
				unset($this->cache[$_port]); }
			
			if(!isset($this->cache[$_port]) and $record = null){
				$this->cache[$_port] = ""; }
			if(!isset($this->cache[$_port])){
				$this->cache[$_port] = $this->record->getField($_port); }
			
			return $this->cache[$_port];
		}

		public function commit(){ return $this->record->commit(); }
		public function delete(){ return $this->record->delete(); }
		abstract public function create();
	}
	
	abstract class cRecordRO extends cRecord{
		protected function field($_port, $_str = null){
			if($this->record == null and !isset($this->cache[$_port])){
				$this->openRecID($this->cache['s_RecID']); }
		
			if(!isset($this->cache[$_port])){
				$this->cache[$_port] = $this->record->getField($_port); }
			
			return $this->cache[$_port];
		}
	}

	class cHour extends cRecordRW{
		const webLayout = 'web_zeiterfassung_Hour';
		
		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cHour::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }
		public function create(){ if($this->record != null) return 1; $this->record =& $this->db->createRecord(cHour::webLayout); return 0; }
		public function delete(){ if($this->record == null) return 1; $this->record->delete(); return 0; }

		public function FKeyMember($_str = null){ return $this->field('f1_FKey_Mitarbeiter', $_str); }
		public function Date($_str = null){
			return strtotime(
				$this->field(
					'f1_Datum',
					(
						$_str != null ? date('m/d/Y', $_str) : null)
					)
			); 
		}


                public function TStart($_str = null){
                    if ($_str == 86400){
                       return strtotime("1/1/1970 ". $this->field('f1_Zeit_Beginn',"24:00:00"));

                    }else {
                        return strtotime("1/1/1970 ". $this->field('f1_Zeit_Beginn',($_str != null ? date('H:i:s', $_str -3600) : null))) +3600;
                    }
		}
             

		public function TEnd($_str = null){
                    if ($_str == 86400){
                       return strtotime("1/1/1970 ". $this->field('f1_Zeit_Ende',"24:00:00"));

                    }else {
                        return strtotime("1/1/1970 ". $this->field('f1_Zeit_Ende',($_str != null ? date('H:i:s', $_str -3600) : null))) +3600;
                    }
		}

		public function Duration($_str = null){ return $this->field('f1_Std', $_str); }
  		public function Notice($_str = null){ return $this->field('f1_Beschreibung', $_str); }
		public function Fee($_str = null){ return $this->field('f1_zh_Flag', $_str); }
		public function FeeCleared($_str = null){ return $this->field('f1_zh_Abgerechnet_Flag', $_str); }
		public function FeeGroup($_str = null){ return $this->field('f1_zh_Kategorie', $_str); }
		public function Token(){ return $this->fieldRO('hour_app_Member::f1_MKrz'); }
		public function fkMember($_str = null){ return $this->field('f1_FKey_Mitarbeiter', $_str); }
		public function ProjectNr(){ return $this->fieldRO('hour_app_Project::f1_Nr'); }
		public function JobNr(){ return $this->fieldRO('hour_app_Job::f1_Nr'); }
		public function fkJob(){ return $this->fieldRO('hour_app_Job::f1_GUID'); }
		public function PositionTitle(){ return $this->fieldRO('hour_app_Position::f1_NrT'); }
		public function PositionNr(){ return $this->fieldRO('hour_app_Position::f1_Nr'); }
		public function fkPosition($_str = null){ return $this->field('f1_FKey_Position', $_str); }
                public function group($_str = null){ return $this->field('f1_Gruppe', $_str); }
                public function factor($_str = null){ return $this->field('f1_Faktor', $_str); }
                public function travel($_str = null){ return $this->field('f1_Reise_Flag', $_str); }
	public function ProjektBezeichnung(){ return $this->fieldRO('hour_app_Project::f1_Bezeichnung'); }
		public function AuftragBezeichnung(){ return $this->fieldRO('hour_app_Job::f1_Bezeichnung'); }
		public function PositionBezeichnung($_str = null){ return $this->field('hour_app_Position::f1_Bezeichnung', $_str); }
	}

	class cJob extends cRecordRO{
		const webLayout = 'web_zeiterfassung_Job';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cJob::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function FKeyProject(){ return $this->field('f1_NrP'); }
		public function Nr(){ return $this->field('f1_Nr'); }
		public function Name(){ return $this->field('f1_Bezeichnung'); }
	}
	
	class cMember extends cRecordRO{
		const webLayout = 'web_zeiterfassung_Member';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cMember::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function Name(){ return $this->field('f3_Name'); }
		public function Token(){ return $this->field('f1_MKrz'); }
		public function LockPast(){ return $this->field('f1_ze_SperreVergangenheit'); }
		public function LockFuture(){ return $this->field('f1_ze_SperreZukunft'); }
                public function activity_begin(){ return $this->field('f1_BeschaeftigungBeginn'); }
                public function activity_end(){ return $this->field('f1_BeschaeftigungEnde'); }
		public function UnlockDate(){ return $this->field('s_mit_ZEFreigabe_Datum');}
		public function FeeGroup(){ return $this->field('f1_zh_Kategorie'); }
                public function distance_from(){ return $this->field('f1_ze_SperreFreigabe_von'); }
                public function distance_to(){ return $this->field('f1_ze_SperreFreigabe_bis'); }
                public function CalenderFKey(){ return $this->field('f1_FKey_Kalender'); }
                public function IDRecord(){ return $this->field('s_RecID'); }
                public function AuswahlJahr_get(){ return $this->field('sv_Auswahl_Jahr'); }
	}

	class cPosition extends cRecordRO{
		const webLayout = 'web_zeiterfassung_Position';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cPosition::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function FKeyJob(){ return $this->field('f1_FKey_Auftrag'); }
		public function Nr(){ return $this->field('f1_Nr'); }
		public function Title(){ return $this->field('f1_NrT'); }
		public function Name(){ return $this->field('f1_Bezeichnung'); }
		public function Project(){ return $this->field('position_app_Project::f1_Nr'); }
		public function Job(){ return $this->field('position_app_Job::f1_Nr'); }
		public function Fee(){ return $this->field('s_ZH_Flag'); }
                public function Group($_str = null){ return $this->field('f3_LPhaseGruppen', $_str); }
	}
	
	class cProject extends cRecordRO{
		const webLayout = 'web_zeiterfassung_Project';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cProject::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function Nr(){ return $this->field('f1_Nr'); }
		public function Name(){ return $this->field('f1_Bezeichnung'); }
	}

	class cUser extends cRecordRO{
		const webLayout = 'web_zeiterfassung_User';
	
		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cUser::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function Name(){ return $this->field('f1_Benutzer'); }
		public function Token(){ return $this->field('f1_Kuerzel'); }
		public function Password(){ return $this->field('f1_Passwort'); }
		public function Group(){ return $this->field('f1_Zugriffsrechte'); }
	 	public function LayoutTyp(){ return $this->field('usr_f1_WebStempeluhr'); }
	}

	class cKomponente extends cRecordRO{
		const webLayout = 'web_zeiterfassung_Register';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cKomponente::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

                public function Komponente(){ return $this->field('ns_WebZeiterfassung_Komponente'); }
	}
	
	class cEinzelprefs extends cRecordRO{
		const webLayout = 'web_zeiterfassung_PRC_Einzelpreferences';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cEinzelprefs::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function accuracy(){ return $this->field('f1_epref_Stempeluhr_EingabeGenauigkeit'); }
	}

		//	class cHour extends cRecordRW{
		//const webLayout = 'web_Hour';


	class cTimeClock extends cRecordRW{
		const webLayout = 'web_zeiterfassung_PRC_MitarbArbeitszeit';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cTimeClock::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }
		public function create(){ if($this->record != null) return 1; $this->record =& $this->db->createRecord(cTimeClock::webLayout); return 0; }
		public function delete(){ if($this->record == null) return 1; $this->record->delete(); return 0; }

		public function GUID($_str = null){ return $this->field('f1_GUID', $_str); }
		public function RecID($_str = null){ return $this->field('s_RecID', $_str); }
		public function Member($_str = null){ return $this->field('f1_FKey_Mitarbeiter', $_str); }
		public function Date($_str = null){ return $this->field('f1_Datum', $_str); }
		public function Begin($_str = null){ return $this->field('f1_Beginn', $_str); }
		public function End($_str = null){ return $this->field('f1_Ende', $_str); }
		public function Notice($_str = null){ return $this->field('f1_Notiz', $_str); }
		public function Pause($_str = null){ return $this->field('f1_Pause', $_str); }
	}

        class cGetSum_ArbeitZeit extends cRecordRO{
      	const webLayout = 'web_zeiterfassung_PRC_MitarbArbeitszeit';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cGetSum_ArbeitZeit::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function FKeyMitarb(){ return $this->field('f1_FKey_Mitarbeiter'); }
		public function date(){ return $this->field('f1_Datum'); }
        public function sum_std(){ return $this->field('usr_sum_Std'); }
        public function ArbeitsStunden(){return $this->field('f3_ArbeitsStunden');}
        public function dev_test(){return $this->field('dev_test');}

	}


        class cGetSum_ProjektZeit extends cRecordRO{
        	const webLayout = 'web_stempeluhr_SumProjektZeit';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cGetSum_ProjektZeit::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function FKeyMitarb(){ return $this->field('f1_FKey_Mitarbeiter'); }
		public function date(){ return $this->field('f1_Datum'); }
                public function StdStd(){ return $this->field('f3_std_std'); }
                public function Std(){ return $this->field('f1_Std'); }
                public function sum_Std(){ return $this->field('sum_summe_Ist_Std'); }

	}
	
	 class cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag extends cRecordRO{
	 		const webLayout = 'web_stempeluhr_Arbeitszeitmodell_Arbeitstag';
	 		
	 public function openRecID($_recid){ $this->record = $this->db->getRecordById(cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }
	 public function FKey_Mitarb(){ return $this->field('f1_FKey_Mitarbeiter'); }
	 public function Typ(){ return $this->field('f1_Typ');}
	 public function Bezeichnung(){ return $this->field('f1_Bezeichnung');}
	 public function date(){ return $this->field('f1_Datum'); }
	 public function ArbeitsStd_Formel(){ return $this->field('f3_ArbeitsStd_Formel');}
	 public function Dauer_Std(){ return $this->field('f3_Dauer_h');}
	 public function Dauer_Tage(){ return $this->field('f1_Dauer_d');}
	 public function ArbeitsStd_Soll(){ return $this->field('f1_ArbeitsStd_Soll');}
	 public function ArbeitsStd_Res(){ return $this->field('f3_ArbeitsStd_Res');}
	 
	 
	 }

    class cGetDayAnalysis extends cRecordRO{
        	const webLayout = 'web_stempeluhr_Kalender';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cGetDayAnalysis::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }

		public function FKeyMitarbeiter(){ return $this->field('f1_FKey_Mitarbeiter'); }
		public function date(){ return $this->field('f1_Datum'); }
		public function ArbeitsStd_soll(){ return $this->field('f1_ArbeitsStd_Soll'); }

	}
	
	class cUeberstunden extends cRecordRO{
		const webLayout = 'web_stempeluhr_ArbeitszeitMan';
	
		public function openRecID($_recid){
			$this->record = $this->db->getRecordById(cGetDayAnalysis::webLayout, $_recid); if(iserror($this->record)) return 1; return 0;
		}
	
		public function FKeyMitarbeiter(){
			return $this->field('f1_FKey_Mitarbeiter');
		}
		public function Monat(){
			return $this->field('f1_Monat');
		}
		public function Jahr(){
			return $this->field('f1_Jahr');
		}
		public function Ueberstunden(){
			return $this->field('f3_Ueberstunden');
		}
		public function UeberstundenToleranz(){
			return $this->field('f3_Ueberstunden_Toleranz');
		}
		public function Resturlaub(){
			return $this->field('f3_Resturlaub');
		}
		public function UeberstundenJahr(){
			return $this->field('f3_Ueberstunden_Jahr_gesamt');
		}
	
	}

    class cGetMitarbUeberstunden extends cRecordRW{
		const webLayout = 'web_zeiterfassung_Member';

		public function openRecID($_recid){ $this->record = $this->db->getRecordById(cGetMitarbUeberstunden::webLayout, $_recid); if(iserror($this->record)) return 1; return 0; }
		public function create(){ if($this->record != null) return 1; $this->record =& $this->db->createRecord(cGetMitarbUeberstunden::webLayout); return 0; }
		public function delete(){ if($this->record == null) return 1; $this->record->delete(); return 0; }


		public function Token(){ return $this->field('f1_MKrz'); }
                //public function AuswahlJahr(){ return $this->field('sv_Auswahl_Jahr'); }
                public function AuswahlJahr($_str = null){ return $this->field('sv_Auswahl_Jahr', $_str); }
                public function std_arberechnungsdatum($_str = null){ return $this->field('sv_stdar_berechnungsdatum', $_str); }
                public function AuswahlJahr_get(){ return $this->field('sv_Auswahl_Jahr'); }
                public function Ueberstunden(){ return $this->field('f4_stdar_std_ueber_formel'); }
                public function Resturlaub(){ return $this->field('f4_url_rest_formel'); }

                public function stdar_ueber01(){ return $this->field('f3_stdar_ueber01'); }
                public function stdar_ueber02(){ return $this->field('f3_stdar_ueber02'); }
                public function stdar_ueber03(){ return $this->field('f3_stdar_ueber03'); }
                public function stdar_ueber04(){ return $this->field('f3_stdar_ueber04'); }
                public function stdar_ueber05(){ return $this->field('f3_stdar_ueber05'); }
                public function stdar_ueber06(){ return $this->field('f3_stdar_ueber06'); }
                public function stdar_ueber07(){ return $this->field('f3_stdar_ueber07'); }
                public function stdar_ueber08(){ return $this->field('f3_stdar_ueber08'); }
                public function stdar_ueber09(){ return $this->field('f3_stdar_ueber09'); }
                public function stdar_ueber10(){ return $this->field('f3_stdar_ueber10'); }
                public function stdar_ueber11(){ return $this->field('f3_stdar_ueber11'); }
                public function stdar_ueber12(){ return $this->field('f3_stdar_ueber12'); }

                

                public function ueberstdtoleranz01(){ return $this->field('f3_UeberStdToleranz_01'); }
                public function ueberstdtoleranz02(){ return $this->field('f3_UeberStdToleranz_02'); }
                public function ueberstdtoleranz03(){ return $this->field('f3_UeberStdToleranz_03'); }
                public function ueberstdtoleranz04(){ return $this->field('f3_UeberStdToleranz_04'); }
                public function ueberstdtoleranz05(){ return $this->field('f3_UeberStdToleranz_05'); }
                public function ueberstdtoleranz06(){ return $this->field('f3_UeberStdToleranz_06'); }
                public function ueberstdtoleranz07(){ return $this->field('f3_UeberStdToleranz_07'); }
                public function ueberstdtoleranz08(){ return $this->field('f3_UeberStdToleranz_08'); }
                public function ueberstdtoleranz09(){ return $this->field('f3_UeberStdToleranz_09'); }
                public function ueberstdtoleranz10(){ return $this->field('f3_UeberStdToleranz_10'); }
                public function ueberstdtoleranz11(){ return $this->field('f3_UeberStdToleranz_11'); }
                public function ueberstdtoleranz12(){ return $this->field('f3_UeberStdToleranz_12'); }
	}

?>